/*
 * Licensed under a Creative Commons Attribution 2.5 Slovenia License
 * http://creativecommons.org/licenses/by/2.5/si/
 * 2009 TineL Studio
 */

package net.tinelstudio.gis.model.domain;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.ManyToMany;

import org.hibernate.annotations.Cascade;
import org.hibernate.annotations.CascadeType;
import org.hibernate.annotations.Type;

import com.vividsolutions.jts.geom.LineString;

/**
 * The WaterLine entity.
 * 
 * @author TineL
 */
@Entity
public class WaterLine extends NotedEntity {

  @Column(nullable=false)
  @Type(type="org.hibernatespatial.GeometryUserType")
  private LineString lineString;

  @Column
  @ManyToMany
  @Cascade(value=CascadeType.SAVE_UPDATE)
  private Set<GeoName> geoNames;

  // ...

  public LineString getLineString() {
    return this.lineString;
  }

  public Set<GeoName> getGeoNames() {
    return this.geoNames;
  }
}