select s
from Street as s
join s.geoNames as geoname
where (lower(geoname.name) like '%cank%' and lower(geoname.name) like '%ul%')
  and geoname.type='STREET'
  
from Street as s
where s in (
  select min(s)
  from Street as s
  join s.geoNames as geoname
  where (lower(geoname.name) like '%cank%' and lower(geoname.name) like '%ul%')
  and geoname.type='TOWN'
  group by geoname.name
)

from Address as a
where ST_distance_sphere(a.point, :point) <= :distance
order by ST_distance_sphere(a.point, :point)

from Address as a
where ST_Intersects(a.point, :bbox) = true
  and ST_distance_sphere(a.point, :point) <= :distance
order by ST_distance_sphere(a.point, :point)

from Address as a
where ST_DWithin(ST_Transform(a.point, :utm),
  ST_Transform(:place, :utm), :distance) = true
order by ST_Distance(ST_Transform(a.point, :utm),
  ST_Transform(:place, :utm))

from Address as a
where ST_Intersects(a.point, :bbox) = true
order by ST_Distance(a.point, :place)

from Street as s
where ST_Intersects(s.lineString, :bbox) = true
  and ST_distance_sphere(:point,
    ST_line_interpolate_point(s.lineString,
      ST_line_locate_point(s.lineString, :point))) <= :distance
order by ST_distance_sphere(:point,
  ST_line_interpolate_point(s.lineString,
    ST_line_locate_point(s.lineString, :point)))

from Building as b
where ST_Intersects(b.polygon, :bbox) = true
  and ST_distance_sphere(:point,
    ST_line_interpolate_point(ST_ExteriorRing(b.polygon),
      ST_line_locate_point(ST_ExteriorRing(b.polygon), :point))) <= :distance
order by ST_distance_sphere(:point,
  ST_line_interpolate_point(ST_ExteriorRing(b.polygon),
    ST_line_locate_point(ST_ExteriorRing(b.polygon), :point)))

from StreetNode as sn
where ST_Intersects(sn.point, :bbox) = true
  and ST_distance_sphere(sn.point, :point) <= :distance
order by ST_distance_sphere(sn.point, :point)

from Street
where startNode = ? or (oneWay = false and endNode = ?)
